package uulm.teamname.marvelous.server.lobbymanager;

import org.java_websocket.WebSocket;
import uulm.teamname.marvelous.gamelibrary.events.Event;

import java.util.HashMap;

public class MessageRelay {

    public static MessageRelay instance;

    private final HashMap<WebSocket, LobbyConnection> lobbies;

    private MessageRelay() {
        this.lobbies = new HashMap<>();
    }

    public static MessageRelay getInstance() {
        if (instance == null) {
            instance = new MessageRelay();
        }
        return instance;
    }

    public void relayMessage (WebSocket conn, String message) {
        var targetLobby = lobbies.get(conn);
        // TODO: Parse JSON
        // TODO: send to target lobby
    }

    public void sendMessage (LobbyConnection origin, Participant recipient, Event[] events) {
        switch (recipient.type) {
            case PlayerOne -> {

            }
            case PlayerTwo -> {

            }
            case Spectator -> {

            }
        }
    }

    /**
     * Broadcasts events to all {@link Participant Participants} of a {@link LobbyConnection}.
     * @param origin is the {@link LobbyConnection} that the {@link Event Events} are broadcasted from
     * @param events are the {@link Event Events} to be broadcasted
     */
    public void broadcastEvents (LobbyConnection origin, Event[] events) {
        // TODO: Create JSON
        // TODO: send to target
    }

    /**
     * Terminates a given {@link LobbyConnection}. This is a End-of-Lifecycle method for
     * {@link LobbyConnection LobbyConnections}, and they may not be reused again.
     * @param origin is the LobbyConnection to be terminated
     */
    public void terminate (LobbyConnection origin) {
        // TODO: implement
    }


}
